
{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O+,R+,S+,Q+,V+,X+}
{$M 16384,0,655360}
program komunikace_citac;

uses Objects, App, Dialogs, Views,Dos, Drivers, Menus, MsgBox,Crt,StdDlg,
     Com,Znak,Memory,HelpFile,HelpCit;


{Pouzite prikazy}
Const

     hcMin          = 0;                   {konstanta Help - kontext}
     hcMax          = $ffff;               {konstanta Help - kontext}
     cmAbout        = 110;                 {informace o vlastnikovi programu,licence ap.}
     cmFrekv        = 111;                 {Ovladaci povely}
     cmPeriod       = 112;
     cmDelImp       = 113;
     cmStrida       = 114;
     cmUziv1        = 115;
     cmUziv2        = 116;
     cmUziv3        = 117;
     cmUziv4        = 118;
     cmUziv5        = 119;
     cmUziv6        = 120;
     cmSoubor       = 121;
     cmPripojCas    = 122;
     cmZmenAdresar  = 123;
     cmCelaPamet    = 124;
     cmPotvrdit     = 125;
     cmNormal       = 126;
     cmVetsi        = 127;
     cmCom1         = 128;
     cmCom2         = 129;
     cmZapUkl       = 130;
     cmPotvrz       = 131;
     cmZac          = 132;
     cmAkt          = 133;
     cmZvAno        = 134;
     cmZvNe         = 135;
     cmOtevri       = 136;

      cr=$b1 ;          { crc polynom}
      K1=#219;          {tabulka semigrafiky}
      K2=#223;
      K3=#220;
      K8=#221;
      K9=#222;
      RX=5+3;
      RY=6;
      VWNr       : Byte = 0;            {pocet otevrenych oken}

Type
    TCitac = Object (TApplication)           {Centralni objekt}

                  {METODY CENTRALNIHO OBJEKTU}
                  Constructor MujInit;                {Inicializace VMT}
                  Procedure InitStatusLine; Virtual;   {Stavovy radek}
                  Procedure InitMenuBar; Virtual;       {Pull-Down Menu}
                  Procedure HandleEvent (Var Event :TEvent);Virtual; {Obsluha udalosti}
                  Procedure Idle;Virtual;             {Procedura vykonavana,kdyz se nic nedeje}
                  Procedure Adresar;                  {Vyber adresare}
                  Procedure Soubor;
                  Procedure NovySoubor;
                  Procedure CZ_Dialog_Box;
                  Procedure ZobrazDialogBox1;
                  Procedure InitSerialKanal(port:byte);
                  Function  VysliKod(Zn:char; poc:byte):boolean;
                  Procedure RozdelJmeno;
                  Procedure Zprava1;
                  Procedure Zprava6;
                  Procedure Zprava2;
                  Procedure UkladaniDat;
                  Procedure NactiData( Povel:char; var Vysl:string);
                  Procedure Zobrazeni_mereni;
                  Procedure ZobrazOkno(X1,Y1,X2,Y2:Integer); {Vytvori nove okno}
                  Procedure PisZnak( KamX,KamY:byte; A:byte);
                  Procedure PisString(q:string; KamX,KamY:byte);
                  Function  Testkey:boolean;
                  Procedure ZobrazVetsi;
                  Procedure Zprava3;
                  Procedure Zprava4;
                  Procedure Zprava5;
                  Procedure Zprava7;
                  Procedure Zprava8;
                  Procedure ZaznamCasu;
                  Procedure VyberCasu;
                  Procedure Pipni;
                  Function  GetPalette: PPalette;Virtual;{barvy pro napovedu}
                  Procedure GetEvent (VAR Event : TEvent);Virtual;
                  Procedure Vyber;
                  Procedure Vypni;
                  end;



    POkno = ^TOkno;
    TOkno=Object(TWindow)
    Constructor Init(Hranice:TRect;Nazev_okna:String;Cislo_okna:Word);
    End;



    PCZ_Dialog_Box1 = ^TCZ_Dialog_Box1;
    TCZ_Dialog_Box1 = Object(TDialog)
    Constructor Init(Rect:TRect;Navesti:String);
    Procedure HandleEvent (Var Event:TEvent);Virtual;
    End;

    PViewWindow = ^TViewWindow;
    TViewWindow = Object (TWindow)
                  Constructor Init (VAR Jmeno_souboru : FNameStr);
                  End;

    PContens       = ^TContens;
    TContens       = Object (TScroller)
                        LineColl : PCollection;
                        IO_OK : Boolean;
                        Constructor Init (Jmeno_souboru : FNameStr;
                                          Var Rect : Trect;
                                          sbH,sbV : PScrollBar);
                        Function Valid (Command : Word) :
                                                  Boolean;Virtual;
                        Procedure Draw; Virtual;
                        Destructor Done;Virtual;
                       End;
    PLineColl  = ^TLineColl;
    TLineColl  = Object (TCollection)
                        Procedure FreeItem (P:Pointer);Virtual;
            End;


      DialogData = Record
               InputLineData : String [4];
               CheckBoxData  : Word
            End;


    Pole1=array[0..300,0..2] of word;
    Pole2=array[0..300] of string[10];


{PROMENNE}

    Var
      Citac               : TCitac;  {Deklarace promenne typu Muj OBJECT}
      Port                :byte;
      PocPokusu           :byte;
      Vysl                :string;
      TestKey             :Boolean;
      X1,X2,Y1,Y2         :Integer;
      Disp,Last,Act       :string[9];
    k,prijem,Konec,bg,Ukladani,VybSoubOK,Cas,Zvuk:boolean;
    pole:array[1..200] of byte;
    ch:char;
    Num,i,Zn:byte;
    NacitaniDat:integer;
    minsec:word;

    PoleCas:Pole1;
    PoleDat:Pole2;
    Data:String;
    rok:word;
    mesic:word;
    den:word;
    den_v_tydnu:word;
    hodina,H:word;
    minuta,M:word;
    sekunda,S:word;
    sec100:word;
    i1:word;
    i2:word;

    D                   :DirStr;       {Tri promenne na uchovani rozdelene}
    J                   :NameStr;      {cesty a jmena souboru}
    E                   :ExtStr;
    F                   :Text;
    R                   :Byte;          {I/O Result}
    Jmeno_souboru       :FNameStr;
    Cislo_portu,Hodnota,
    Hodnota1            :Byte;
    FileDialog          :PFileDialog;
    Radek1,Radek2,
    Radek3,Radek4       :String;        {Text predavany v CZ dialogovem boxu}
    Navesti,Navesti1    :String;        {Text v hornim radku CZ dialogoveho boxu}
    InputLn             :PInputLine;
    InputLineData       :String;
    Param,x,Time       :Integer;
    BoxData            :DialogData;










    {----Ukazatele------}

     Okno            :POkno;
     Dialog	     :PDialog;
      Window : PWindow;
{-----------------------------------------------}
Constructor TCitac.MujInit;   {Inicializace VMT,po spusteni programu zakaz prikazy }
Begin
DisableCommands([cmFrekv,cmPeriod,cmDelImp,cmStrida,cmUziv1,cmUziv2,
                 cmUziv3,cmUziv4,cmUziv5,cmUziv6,cmNormal,cmVetsi,
             cmPripojCas,cmZapUkl,cmZvNe,cmSoubor]);

RegisterHelpFile;  {registrace napovedneho souboru}
End;
{-----------------------------------------------}
Procedure TCitac.InitStatusLine;    {vytvoreni stavoveho radku}
VAR
Rect : TRect;
Begin
	GetExtent (Rect);			{urceni koordinat pravouhelniku}
	Rect.A.Y:=Pred (Rect.B.Y);		{rezervovani nejspodnejsiho radku}
	StatusLine:=
	  New (PStatusLine,Init (Rect,
		NewStatusDef (hcMin,hcMax,
                NewStatusKey('~F1~ Napoveda',kbF1,cmHelp,
		NewStatusKey('~F2~ Frekvence',kbF2,cmFrekv,
		NewStatusKey('~F3~ Perioda',kbF3,cmPeriod,
		NewStatusKey('~F4~ Delka Impulsu',kbF4,cmDelImp,
		NewStatusKey('~F5~ Strida',kbF5,cmStrida,
		NewStatusKey('~F10~ Menu',kbF10,cmMenu,
                NewStatusKey('~Alt+X~ Exit',kbAltX,cmQuit,
                NIL))))))),			{NewStatusKey}
	NIL)					{NewStatusDef}
	))
End;
{---------------------------------------------------------------}
Procedure TCitac.InitMenuBar;   {vytvoreni pull-down menu}
Var
Rect: TRect;
Begin
	GetExtent (Rect);		{urceni koordinat pravouhelniku}
	Rect.B.Y:=Succ(Rect.A.Y);	{horni radek obrazovky}
	MenuBar:=
	New (PMenuBar, Init (Rect,NewMenu (
	  NewSubMenu('~'#1'~',hcNoContext, NewMenu(
		        NewItem('~I~nfo','',kbNoKey, cmAbout, hcNoContext,
		        NewLine(
		        NewItem('~E~xit','',kbNoKey,cmQuit,hcNoContext,Nil)))),
          NewSubmenu ('Volba portu',hcNoContext,NewMenu (
			NewItem ('COM 1','',kbNoKey,cmCom1,hcPorty,
                        NewItem ('COM 2','',kbNoKey,cmCom2,hcPorty,
                        Nil))),
          NewSubmenu ('Ovladani',hcNoContext,NewMenu (
			NewItem ('Frekvence','F2',kbF2,cmFrekv,hcFrekvence,
			NewItem ('Perioda','F3',kbF3,cmPeriod,hcPerioda,
			NewItem ('Delka impulsu','F4',kbF4,cmDelImp,hcDelkaImpulsu,
                        NewItem ('Strida','F5',kbF5,cmStrida,hcStrida,
                        NewLine(
                        NewItem ('Uziv. vstup 1','  Alt+F2',kbAltF2,cmUziv1,hcNoContext,
                        NewItem ('Uziv. vstup 2','  Alt+F3',kbAltF3,cmUziv2,hcNoContext,
                        NewItem ('Uziv. vstup 3','  Alt+F4',kbAltF4,cmUziv3,hcNoContext,
                        NewItem ('Uziv. vstup 4','  Alt+F5',kbAltF5,cmUziv4,hcNoContext,
                        NewItem ('Uziv. vstup 5','  Alt+F6',kbAltF6,cmUziv5,hcNoContext,
                        NewItem ('Uziv. vstup 6','  Alt+F7',kbAltF7,cmUziv6,hcNoContext,
                        NewLine(
                        NewSubmenu('Zvukovy signal pri chybe',hcZvukPriChybe,NewMenu(
                                NewItem ('ANO','',kbNoKey,cmZvAno,hcNoContext,
                                NewItem ('NE','',kbNoKey,cmZvNe,hcNoContext,Nil))),
			NIL)))))))))))))),
          NewSubmenu ('  Data na obrazovku',hcDataNaObrazovku,NewMenu (
                        NewItem ('Normalni velikost','F8',kbF8,cmNormal,hcNormalniVelikost,
                        NewItem ('Zvetsena velikost','F9',kbF9,cmVetsi,hcZvetsenaVelikost,
                        Nil))),
          NewSubmenu ('  Soubor',hcSoubor,NewMenu(
                         NewSubMenu ('Data ukladat',hcUkladat,NewMenu(
                                     NewItem ('Soubor','Alt+S',kbAltS,cmSoubor,hcUlozSoubor,
                                     NewItem ('Zmena adresare','Alt+A',kbAltA,cmZmenAdresar,hcNoContext,
                                     NewLine (
                                     NewItem ('Spustit','Alt+M',kbAltM,cmZapUkl,hcSpustit,Nil))))),
                         NewLine(
                         NewSubMenu ('Data cist',hcCist,NewMenu(
                                     NewItem ('Otevrit soubor ','Alt+O',kbAltO,cmOtevri,hcOtevriSoubor,
                                     NewItem ('Zmena adresare','Alt+A',kbAltA,cmZmenAdresar,hcNoContext,Nil))),

                        Nil)))),
               	Nil))))))))
End;
{------------------------------------------------------}
Procedure TCitac.HandleEvent(Var Event: TEvent);    {Zpracovani udalosti}
Var
R:TRect;
Begin
  TApplication.HandleEvent(Event);
  If Event.What = evCommand Then
   Begin
    Case Event.Command Of
          cmAbout :     Begin                    {Info o autorovi}
                        Zprava1;
                        CZ_Dialog_Box;
                        End;
          cmFrekv    :
                        Begin                    {Volba merici funkce}
                        VysliKod('S',3);         {Kod povelu / }
                        VysliKod('1',3);         {cislo kanalu}
                        End;

          cmPeriod   :  Begin
                        VysliKod('S',3);         {Kod povelu / }
                        VysliKod('2',3);         {cislo kanalu}
                        End;

          cmDelImp   :   Begin
                         VysliKod('S',3);        {Kod povelu / }
                         VysliKod('3',3);        {cislo kanalu}
                         End;

          cmStrida   :   Begin
                         VysliKod('S',3);        {Kod povelu / }
                         VysliKod('4',3);        {cislo kanalu}
                         End;

             cmSoubor:   Begin                   {Urceni jmena souboru a jeho otevreni}
                         Soubor;                 {Dialog box pro urceni jmena souboru}
                         NovySoubor;
                         End;

     cmZmenAdresar:      Adresar;                {Zmena adresare}

           cmUziv1:      Begin                    {Uzivatelske funkce}
                         VysliKod('S',3);         {Kod povelu / }
                         VysliKod('5',3);         {cislo kanalu}
                         End;

           cmUziv2:      Begin
                         VysliKod('S',3);         {Kod povelu / }
                         VysliKod('6',3);         {cislo kanalu}
                         End;

           cmUziv3:      Begin
                         VysliKod('S',3);         {Kod povelu / }
                         VysliKod('7',3);         {cislo kanalu}
                         End;

           cmUziv4:      Begin
                         VysliKod('S',3);         {Kod povelu / }
                         VysliKod('8',3);         {cislo kanalu}
                         End;

           cmUziv5:      Begin
                         VysliKod('S',3);         {Kod povelu / }
                         VysliKod('9',3);         {cislo kanalu}
                         End;

           cmUziv6:      Begin
                         VysliKod('S',3);         {Kod povelu / }
                         VysliKod('A',3);         {cislo kanalu}
                         End;

            cmCom1:      Begin                   {Volba portu a jeho inicializace}
                         Port:=com1;             {a povoli prikazy}
                         InitSerialKanal (Port);
                         EnableCommands([cmFrekv,cmPeriod,cmDelImp,cmStrida,cmUziv1,cmUziv2,
                         cmUziv3,cmUziv4,cmUziv5,cmUziv6,cmNormal,cmVetsi,cmPripojCas,
                         cmZapUkl,cmSoubor]);
                         End;

            cmCom2:      Begin
                         Port:=com2;
                         InitSerialKanal (Port);
                         EnableCommands([cmFrekv,cmPeriod,cmDelImp,cmStrida,cmUziv1,cmUziv2,
                         cmUziv3,cmUziv4,cmUziv5,cmUziv6,cmNormal,cmVetsi,cmPripojCas,
                         cmZapUkl,cmSoubor]);
                         End;

           cmVetsi:      Begin                   {Zobrazi vetsi okno a v nem zobrazi data}
                         ZobrazOkno(1,3,70,15);  {nactena z displeje-nacita segmenty displeje}
                         ZobrazVetsi;            {proto zobrazuje vse,co displej}
                         Okno^.Close;
                         End;


          cmNormal:      Begin                   {Zobrazi mensi okno a v nem vysledky mereni}
                         ZobrazOkno(5,5,60,10);  {nenacita z displeje,proto pri prechodu do}
                         Zobrazeni_mereni;       {editace funkci citace ohlasi chybu!!}
                         Okno^.Close;
                         End;

          cmZapUkl:      Begin
                         If Not VybSoubOK Then Begin               {Spusti ukladani do souboru,predtim otestuje,zda byl}
                                               Zprava7;            {soubor korektne vybran a otevren-param VybSoubOK a nastavi}
                                               CZ_Dialog_Box;      {pokud ne,zobrazi chybovou zpravu a nepovoli ukladani}
                                               Ukladani:=False;
                                               End
                         Else Vyber;                               {Pokud vse OK,pokracuj}
                              End;

         cmZvAno:       Begin
                         DisableCommands([cmZvAno]);{Procedura pro nastaveni pipnuti u chyb. hlaseni}
                         EnableCommands([cmZvNe]);
                         Zvuk:=True;
                         pipni;
                         End;

         cmZvNe:        Begin                         {Totez,ale zruseni}
                         DisableCommands([cmZvNe]);
                         EnableCommands([cmZvAno]);
                         Zvuk:=False;
                         End;

        cmOtevri:        Begin                   {Otevreni souboru pro cteni}
                         Soubor;
                         Window:=PWindow (ValidView (New (PViewWindow, Init (Jmeno_souboru))));
		         DeskTop^.Insert(Window);
                         End;


          End;
      End;
ClearEvent(Event);
End;
{-----------------------------------------------}
Procedure TCitac.GetEvent(var Event:TEvent);   {Zpracovani udalosti hlavniho objektu-nutno pro funkci help}
VAR
  W: PWindow;
  HFile: PHelpFile;
  HelpStrm: PDosStream;
const
  HelpInUse: Boolean = False;
Begin
	TApplication.GetEvent(Event);
	If (Event.What = evCommand) and
	   (Event.Command = cmHelp) and not HelpInUse then
			Begin
			 HelpInUse :=True;      {Nalezeni helpfile}
			 HelpStrm := New(PDosStream, Init('helpcit.hlp', stOpenRead));
			 HFile := New (PHelpFile, Init(HelpStrm));
			 if HelpStrm^.Status <> stOk then
				Begin
				 Citac.Zprava8;          {Chybove hlaseni-helpfile neni}
                                 CZ_Dialog_Box;
				 Dispose(HFile, Done);
				End
			 else
			 Begin
			  W :=New(PHelpWindow,Init(HFile, GetHelpCtx));
			  if ValidView(W) <> nil then
			  Begin
			   ExecView(W);
			   Dispose(W,Done);
			  End;
			  ClearEvent(Event);
			 End;
			 HelpInUse := False
		       End;
End;
{-----------------------------------------------}
Function TCitac.GetPalette: PPalette;       {Volba barevne palety pro napovedu}
const
   CNewColor = CAppColor + CHelpColor;
   CNewBlackWhite = CAppBlackWhite + CHelpBlackWhite;
   CNewMonochrome = CAppMonochrome + CHelpMonochrome;
   P: array[apColor..apMonochrome] of string[Length(CNewColor)] =
	(CNewColor, CNewBlackWhite, CNewMonochrome);
   Begin
	GetPalette := @P[AppPalette];
   End;
{-----------------------------------------------}
Procedure TCitac.Idle;  {Tato procedura je vykonavana vzdy,kdyz neni pozadavek nejake cinnosti na program}
Begin                   {je v ni vycitani realneho casu a porovnavani s nastavenym intervalem mereni}
TApplication.Idle;      {V zavislosti na tom se meri nebo ne}
If Ukladani Then Begin
                 Gettime (hodina,minuta,sekunda,sec100);
                 If minsec<>sekunda then    Begin
                                            minsec:=sekunda;
                                            Inc (Time);
                                            If Time = NacitaniDat Then Begin   {Byl dosazen interval,jdi na mereni dat}
                                                                       UkladaniDat;
                                                                       Time:=0;
                                                                       End;
                                            End;
                 End;
End;
{Protoze hodimy a minuty jsou do 60, a zadavany interval mereni je v sekundach od 1 do 3000,aby se nemusel delat prevod}
{je vzdy po sekunde incrementovana promenna TIME a porovnavana s promennou Nacitani dat v ktere je interval nacitani}
{------------------------------------------------------}
{Hlavni zobrazovaci okno - init}
Constructor TOkno.Init (Hranice:TRect;Nazev_okna:String;Cislo_okna:Word);
   Begin
     TWindow.Init(Hranice,Nazev_okna,wnNoNumber);
     Options:=ofSelectable or ofCentered;
     Flags:=0;
     Palette:=wpGrayWindow;
End;
{------------------------------------------------}
{Vlozi na desktop okno na souradnicich X1,X2,Y1,Y2}
Procedure TCitac.ZobrazOkno(X1,Y1,X2,Y2:Integer);
Var
    R:TRect;
Begin
     R.Assign(X1,Y1,X2,Y2);
     Okno:=New(POkno,Init(R,'PRO UKONCENI STISKNETE LIBOVOLNOU KLAVESU',wnNoNumber));
     InsertWindow(Okno);
     End;
{------------------------------------------------}
{Zmena aktivniho adresare}
Procedure TCitac.Adresar;
VAR
Dialog: PChDirDialog;
Begin
   New(Dialog, Init(cdNormal,100));	{normalni zobrazeni}
   If ValidView(Dialog) <> Nil Then
	Begin
	 DeskTop^.ExecView(Dialog);
	 Dispose (Dialog, Done);
	End;
End;
{------------------------------------------------}
{Vytvoreni boxu pro vyber souboru pro ulozeni nebo otevreni}
Procedure TCitac.Soubor;
Const
  FDOptions: Word = fdOKButton or fdOpenButton;
Begin
  Jmeno_souboru:='*.mer';
  New(FileDialog, Init(Jmeno_souboru,'Vyber souboru','Soubor',
    fdOKButton, 1));
  ExecuteDialog(FileDialog, @Jmeno_souboru);
End;
{------------------------------------------------}
{Cesky dialogovy box resp. Info box se 4 radky na zpravu a tlacitkem 'ZAVRIT'}
Procedure TCitac.CZ_Dialog_Box;
Var
Rect	: TRect;
Begin
        If Zvuk Then Pipni;             {Pokud je pozadavek zvuku pri zobrazeni,pipni}
  	Rect.Assign (20,4,60,14);	{udaje pro pravouhelnik}
	Dialog :=
	  New (PDialog,Init (Rect,Navesti));
	  With Dialog^ Do
	  	Begin
		Rect.Assign (5,2,38,3);	{umisteni textu 1. radku}
		Insert (New (PLabel,Init (Rect,Radek1,nil)));
                Rect.Assign (5,3,38,4); {umisteni textu 1. radku}
		Insert (New (PLabel,Init (Rect,Radek2,nil)));
                Rect.Assign (5,4,38,5); {umisteni textu 1. radku}
		Insert (New (PLabel,Init (Rect,Radek3,nil)));
                Rect.Assign (5,5,38,6); {umisteni textu 1. radku}
		Insert (New (PLabel,Init (Rect,Radek4,nil)));
                Rect.Assign (15,7,25,9); {udaje pro tlacitko ZAVRIT}
		Insert (New (PButton,Init (Rect,'Zavrit',cmCancel,bfNormal)));
		SelectNext (False);
                DeskTop^.ExecView(Dialog);
    End;
End;
{-------------------------------------------------}
Constructor TCZ_Dialog_Box1.Init;
Begin
                TDialog.Init(Rect,Navesti);
                Rect.Assign (3,2,48,3);	{udaje pro seznam pouzitych textu}
		Insert (New (PLabel,Init (Rect,Radek1,nil)));
                Rect.Assign (5,3,38,4);	{udaje pro seznam pouzitych textu}
		Insert (New (PLabel,Init (Rect,Radek2,nil)));
                Rect.Assign (5,5,38,6);	{udaje pro seznam pouzitych textu}
		Insert (New (PLabel,Init (Rect,Radek3,nil)));
                Rect.Assign (7,5,42,7); {udaje pro tlacitko Cancel}
		Insert (New (PButton,Init (Rect,'Data ukladat od zacatku souboru',cmZac,bfNormal)));
                Rect.Assign (3,7,47,9);
                Insert (New (PButton,Init (Rect,'Pokracovat v ukladani od aktualni pozice',cmAkt,bfNormal)));
                Rect.Assign (20,9,30,11);
                Insert (New (PButton,Init (Rect,'Storno',cmCancel,bfNormal)));
                SelectNext (False);
    End;
{-------------------------------------------------}
Procedure TCitac.ZobrazDialogBox1;
Var
Rect	: TRect;
Begin
Rect.Assign (10,4,60,16);	{udaje pro pravouhelnik}
Dialog :=New (PCZ_Dialog_Box1,Init (Rect,Navesti));
InsertWindow(Dialog);
End;
{--------------------------------------------------------}
{Obsluha udalosti pro vyber u souboru ktery jiz existuje,zda ukladat od zacatku,nebo pokracovat od aktualni pozice}
Procedure TCZ_Dialog_Box1.HandleEvent (Var Event:TEvent);
Begin
     TDialog.HandleEvent(Event);
  If Event.What = evCommand Then
      Case Event.Command Of

          cmZac :       Begin
                        Rewrite(F);
                        Dialog^.Close;
                        VybSoubOK:=True;
                        Citac.Vyber;
                        End;
          cmAkt:        Begin
                        Append(F);
                        Dialog^.Close;
                        VybSoubOK:=True;
                        Citac.Vyber;
                        End;
          cmCancel:     Dialog^.Close;
End;
End;
{------------------------------------------------}
{Zpravy predavane dialogovemu a input boxu}
Procedure TCitac.Zprava1;
Begin
Navesti:='Informace o programu';
Radek1:='  Komunikacni software pro';
Radek2:='     UNIVERZALNI CITAC ';
Radek3:='';
Radek4:='David Hankovec  DH servis 2001';
End;
{-------------------------------------------}
Procedure TCitac.Zprava2;
Begin
Navesti:='POZOR';
Radek1:='Nastala chyba v komunikaci s';
Radek2:='citacem.Zkontrolujte,zda je';
Radek3:='citac zapnuty a kabel RS232';
Radek4:='     spravne zapojeny.';
End;
{------------------------------------------------}
Procedure TCitac.Zprava3;
Begin
Navesti:='Zadani intervalu mereni';
Radek1:='    Zadejte po kolika vterinach chcete';
Radek2:='  provadet mereni v intervalu 0-3000 sec.';
Radek3:='sekund';
End;
{------------------------------------------------}
Procedure TCitac.Zprava4;
Begin
Navesti:='POZOR';
Radek1:='';
Radek2:='      Zadani casu neni';
Radek3:='     v platnych mezich !';
Radek4:='';
End;
{------------------------------------------------}
Procedure TCitac.Zprava5;
Begin
Navesti:='POZOR';
Radek1:='';
Radek2:=' Nastal problem s pristupem';
Radek3:='         k souboru !';
Radek4:='';
End;
{-------------------------------------------}
Procedure TCitac.Zprava6;
Begin
Navesti:='POZOR';
Radek1:='     Soubor: '+J+E+'  jiz existuje !!' ;
Radek2:='       Chcete do neho ukladat ?';
Radek3:='';
Radek4:='';
End;
{------------------------------------------------}
Procedure TCitac.Zprava7;
Begin
Navesti:='POZOR';
Radek1:='';
Radek2:='Neni urcen vystupni soubor !';
Radek3:='';
Radek4:='';
End;
{------------------------------------------------}
Procedure TCitac.Zprava8;
Begin
Navesti:='POZOR';
Radek1:='';
Radek2:=' Nastal problem s pristupem';
Radek3:='   k souboru s napovedou !';
Radek4:='';
End;
{------------------------------------------------}
{Inicializace seriove linky}
Procedure TCitac.InitSerialKanal(port:byte);
Var a:byte;
Begin
  NastavCom(Port,1200,zadna,8,1);
  delay(50);
  While PrectiZnak(Port,1,a) do;
End;
{------------------------------------------------}
{tato funkce vysle povel "Zn" do citace. "Poc" predstavuje pocet pokusu }
function TCitac.VysliKod(Zn:char; poc:byte):boolean;
var i:byte;
    k:boolean;
    x:byte;
begin
  i:=0;
  repeat
    inc(i);
    VysliZnak(Port,ord(Zn));
    k:=PrectiZnak(Port,30,x);
    k:=k and (x=ord(Zn));
  until k or (i=poc);              {poc pokusu}
  VysliKod := k;
end;
{-------------------------------------------------}
{Nacteni vysledneho stringu z citace "Vysl". Typ povelu je v "Povel". }
{Pokud nejsou nactena zadna data nebo je-li vadne CRC, tak Vysl = ''  }
Procedure TCitac.NactiData( Povel:char; var Vysl:string);
Var
pole:array[1..200] of byte;
i,j,Zn:byte;
k,bg:boolean;
Stradac:word;

Begin
  FillChar(pole, SizeOf(pole), 0);
  If Not VysliKod( Povel, 3) Then Begin
                                  Vysl:='';  {Pokud neni odezva citace,Vysl='',zobraz chyb.hlaseni}
                                  End

Else
  Begin
  i:=0;
  bg:=false;
  Repeat                        {nacteni dat z citace do "pole" }
    k:=PrectiZnak(Port,30,Zn);
    If k Then Begin
      bg:=true;
      inc(i);
      pole[i]:=Zn
    End;
      Until bg And Not k;

  If i>0 Then Begin             {otestovani CRC prijatych dat }
    Stradac := $ff mod cr;
    For j:=2 to pred(i) do
      Stradac := (Stradac shl 8 + pole[j]) mod cr;

    If Stradac = pole[i] Then Begin
      move(pole[3], Vysl[1], i-3);
      Vysl[0] := chr(i-3);
    End
    Else Vysl := '';
End;
End;
End;
{------------------------------------------------}
Procedure TCitac.NovySoubor;   {Vytvoreni noveho souboru po vybrani jmena v procedure Soubor}
Begin
     Assign(F,Jmeno_souboru);
     {$I-} Reset(F); {$I+}
     r:=IOResult;
     IF r = 0 then begin        {pokud r=0,soubor jiz existuje}
                   RozdelJmeno; {Rozdeli jmeno souboru a zobrazi dialog ve kterem}
                   Zprava6;     {se urci,zda ukladat do souboru od zacatku nebo od aktualni pozice}
                   ZobrazDialogBox1;
                   End
   Else Begin
          If Jmeno_souboru <> ('*.mer') Then Begin          {pokud soubor neexistuje,otevri jej,otestuj I/O a nastav parametr}
                                             Rewrite(F);    {ze byl korektne vybran soubor}
                                             r:=IOResult;
                                             IF r = 0 then VybSoubOK:=True;
                                                End
                                             Else
                                                 Begin        {pokud I/O neni ok,vypis zpravu o problemu s pristupem k souboru}
                                                 Zprava7;
                                                 CZ_Dialog_Box;
                                                 End;
                                             End;

          If Jmeno_Souboru = ('*.mer') Then VybSoubOK:=False;  {pokud nebyl zadan vystupni soubor a okno bylo odeslano "OK",}
          End;                                                 {nuluj parametr,ze nebyl vybran vystupni soubor}
{------------------------------------------------}
Procedure TCitac.RozdelJmeno;
Begin
     FSplit(Jmeno_souboru, D, J, E);             {rozdeleni plne cesty na soubor a priponu}
End;
{------------------------------------------------}
Function TCitac.TestKey;        {testuje stisknuti libovolne klavesy}
var ch:char;
begin
  if not KeyPressed then TestKey:=false
  else begin
    ch:=ReadKey;
    if ch=#0 then ch:=ReadKey;
    TestKey:=true
  end
end;
{------------------------------------------------}
Procedure TCitac.Zobrazeni_mereni;  {Zobrazi data do okna v normalni velikosti}
Label konec;                        {POZOR,pracuje tak,ze vycita mereni citace,ne displej}
Var                                 {proto pri prechodu do editace na citace zahlasi chybu v komunikaci}
vysl:string;
Begin
 InitSerialKanal (Port);

 Repeat
  Begin
    NactiData('M',Vysl);
      if Vysl = '' then
            Begin
            PocPokusu := 3;           { chybna data se pokousime nacist 3x }
                      repeat
                      NactiData('O',Vysl);       { opakovani }
                      PocPokusu:=PocPokusu-1;
                      until (PocPokusu = 0) or (Vysl <> '');
            end;
                     if Vysl <> '' then okno^.WriteStr (20,2,Vysl,1) {zapis data do okna}


               else    Begin             {Neplatna data,zobrazeni dialogu o chybe v komunikaci}
                       Zprava2;
                       CZ_Dialog_Box;
                       Goto konec;   {odchod z rutiny}
                       End;


  end;
 until testkey;
konec:
end;
{------------------------------------------------}
Procedure TCitac.ZobrazVetsi;   {Totez jako predchozi,ale zobrazi data zvetsene pomoci semigrafiky}
Label konec1;                   {Tato procedura cte obsah displeje,proto funguje i po prechodu do}
Begin                           {editace parametru citace}
 InitSerialKanal (Port);
  Disp:='';
  Act :='';
  repeat

    if not VysliKod('D',3) then begin      { Vyslani povelu "Nacti Display "}
                                Zprava2;
                                CZ_Dialog_Box;
                                Goto konec1;   {odchod z rutiny}
                                end;

    i:=0;                                  { nacteni odpovedi }
    bg:=false;
    repeat
      k:=PrectiZnak(Port,20,Zn);
      if k then begin
        bg:=true;
        inc(i);
        pole[i]:=Zn
      end;
    until bg and not k or (i=8);

    if i>0 then begin                      { zobrazeni }
      Act[0]:=chr(i);
      move(pole,Act[1],i);
      if Disp<>Act then PisString(Act,4,3);
      Disp:=Act;
    end;
  until TestKey;
konec1:
end;
{------------------------------------------------}
Procedure TCitac.PisZnak( KamX,KamY:byte; A:byte);   {zobrazeni jednoho znaku}
var i:byte;
    B:TDrawBuffer;
    Barva:Byte;

begin
   barva:=2;

   if boolean(a and $01) then begin
     MoveChar(B,K3,GetColor(Barva),5);       { vypln buffer podkladem }
     Okno^.WriteLine(KamX,KamY,5,1,B);
   end;

   if boolean(a and $08) then
     for i:=0 to 4 do begin
     MoveChar(B,K3,GetColor(Barva),1);       { vypln buffer podkladem }
     Okno^.WriteLine(KamX+i,KamY+4,1,1,B);
     end;

   if boolean(a and $40) then
     for i:=0 to 4 do begin
     MoveChar(B,K3,GetColor(Barva),1);       { vypln buffer podkladem }
     Okno^.WriteLine(KamX+i,KamY+2,1,1,B);

   end;

   if boolean(a and $02) then
     for i:=0 to 2 do begin
     if i=0 then Begin
                 MoveChar(B,K3,GetColor(Barva),1);       { vypln buffer podkladem }
                 Okno^.WriteLine(KamX+4,KamY+i,1,1,B);
                 End
            else Begin
                 MoveChar(B,K1,GetColor(Barva),1);       { vypln buffer podkladem }
                 Okno^.WriteLine(KamX+4,KamY+i,1,1,B);
   end;
End;

   if boolean(a and $04) then
     for i:=0 to 1 do begin
     MoveChar(B,K1,GetColor(Barva),1);       { vypln buffer podkladem }
     Okno^.WriteLine(KamX+4,KamY+i+3,1,1,B)
     end;

   if boolean(a and $20) then
     for i:=0 to 2 do begin
     if i=0 then Begin
                 MoveChar(B,K3,GetColor(Barva),1);       { vypln buffer podkladem }
                 Okno^.WriteLine(KamX,KamY+i,1,1,B);
                 End
            else Begin
                 MoveChar(B,K1,GetColor(Barva),1);       { vypln buffer podkladem }
                 Okno^.WriteLine(KamX,KamY+i,1,1,B)

   end;
end;

   if boolean(a and $10) then
     for i:=0 to 1 do begin
     MoveChar(B,K1,GetColor(Barva),1);       { vypln buffer podkladem }
     Okno^.WriteLine(KamX,KamY+i+3,1,1,B);
   end;

   if boolean(a and $80) then begin
     MoveChar(B,K3,GetColor(Barva),1);       { vypln buffer podkladem }
     Okno^.WriteLine(KamX+6,KamY+4,1,1,B);
   end;
end;

Procedure TCitac.PisString(q:string; KamX,KamY:byte);
var i:byte;
    B:TDrawBuffer;
Begin
  Begin
      MoveChar(B, #255, GetColor(3),68);       { vypln buffer podkladem }
      Okno^.WriteLine(Self.Cursor.X+1,Self.Cursor.Y+1,67,10,B);
    end;

  for i:=1 to length(q) do begin
    PisZnak(KamX,KamY,ord(q[i]));
    inc(KamX, RX)
  end;
end;
{------------------------------------------------}
Procedure TCitac.UkladaniDat;  {Ukladani dat do souboru}
Var
x,y:String;

Begin
    NactiData('M',Vysl);
      if Vysl = '' then
            Begin
            PocPokusu := 3;           { chybna data se pokousime nacist 3x }
                      repeat
                      NactiData('O',Vysl);       { opakovani }
                      PocPokusu:=PocPokusu-1;
                      until (PocPokusu = 0) or (Vysl <> '');
            end;
                     if Vysl <> '' then Begin
                                        PoleDat[i2]:=Vysl; {zapis dat do pole}
                                        If Cas Then ZaznamCasu;  {kontrola pozadavku na zaznam casu k datum}
                                        i2:=i2+1;
                                        End
               else    Begin             {Pokud je vysledek vycteni dat z citace neplatny,zastav nacitani a zobraz chybu}
                       Ukladani:=False;    {Zastav ukladani dat}
                       Zprava2;
                       CZ_Dialog_Box;
                       End;

If i2=NacitaniDat Then Begin   {interval ukladani dat do souboru = zvoleny interval mereni v sec.}
              i2:=0;   {Index pole na zacatek}
              Append(F);
              Repeat
              If Cas Then Begin
                          VyberCasu;     {Vyber casova data.Protoze pri casech do 10 je zobrazeno jen napr 5 a ne 05}
                          x:=':';        {je nize provedena uprava pro stejny zapis vsech dat do souboru}
                          y:=':';
                          IF s<10 Then x:=':0';
                          IF m<10 Then y:=':0';
                          Write (F,h,y,m,x,s,'    ');
                          End;
              Data:= PoleDat[i2];
              WriteLn (F,Data);
              i2:=i2+1;
              Until i2=NacitaniDat;
              i2:=0;
              Close(F);
              End;

      End;
{------------------------------------------------}
Procedure TCitac.ZaznamCasu; {Uloz data casu do pole}
Begin
i1:=0;
PoleCas[i2,i1]:=Hodina;
Inc (i1);
PoleCas[i2,i1]:=Minuta;
Inc (i1);
PoleCas[i2,i1]:=Sekunda;
End;
{------------------------------------------------}
Procedure TCitac.VyberCasu;   {Vyber data casu z pole}
Begin
i1:=0;
H:=PoleCas[i2,i1];
Inc (i1);
M:=PoleCas[i2,i1];
Inc (i1);
S:=PoleCas[i2,i1];
End;
{------------------------------------------------}
Procedure TCitac.Pipni; {Vyloudi pipnuti ze speakru PC}
Var
y:Integer;
Begin
y:=0;
Sound (1000);
Delay(500);
NoSound;
End;
{------------------------------------------------}
Constructor TViewWindow.Init;
{inicializace okna pro zpracovani textu,souboru s daty}
VAR
  Rect	:TRect;		{ohraniceni okna}
BEGIN
	DeskTop^.GetExtent(Rect);		{urceni koordinat desktopu}
	Inc(VWNr);				{zvyseni poctu otevrenych oken}
	TWindow.Init (Rect,Jmeno_souboru,VWNr);		{inicializace otcovskeho objektu}
	GrowMode :=gfGrowHiX + gfGrowHiY;
	Options:=Options OR (ofTileable + ofSelectable + ofFramed); {Parametry okna}
	GetClipRect(Rect);			{ohraniceni aktivniho okna}
	Rect.Grow (-1,-1);			{zmenseni rozmeru o 1 pro oba smery}
	Insert (New (PContens,Init (Jmeno_souboru,Rect,
		StandardScrollBar (sbHorizontal + sbHandleKeyBoard),
		StandardScrollBar (sbVertical + sbHandleKeyBoard))))
End;
{------------------------------------------------}
Constructor TContens.Init;
 {Zavedeni textoveho souboru,tvorba kolekce}
	VAR
	 TextFile   : Text;     {textovy soubor}
	 MaxLength  : Byte;	{Maximalni delka radku}
	 Control    : Word;	{navratova hodnota okna pro zobrazeni zpravy}
	 S          : String;	{nacitany textovy radek}


Function OtevriSoubor : Boolean;
 {True,kdyz se textovy soubor mohl uspesne otevrit}
	Begin
	 Assign (TextFile,Jmeno_souboru);		{Priradeni jmena souboru}
	{$I-}				{vypnuti kontroly IO chyb}
	 Reset (TextFile);		{nastaveni ukazatele souboru}
	{$I+}				{obnova kontroly IO chyb}
	 OtevriSoubor := IOResult = 0	{nastaveni hodnoty}
	End;

BEGIN
 TScroller.Init (Rect,sbH,sbV);		{inicializace objektu predchudce}
 GrowMode := gfGrowHiX+gfGrowHiY;	{posuv praveho dolniho rohu}
 IO_OK:=True;
 LineColl:=New (PLineColl,Init(5,5));	{urceni kolekce}
 IF OtevriSoubor Then
	Begin
	 MaxLength:=0;
          While Not Eof (TextFile) AND Not LowMemory Do
		Begin
		 ReadLn (TextFile,S);	{cteni textoveho radku}
		 LineColl^.Insert (NewStr(S));	{zavedeni do kolekce}
		 If Length (S) > MaxLength then MaxLength:=Length (S);
		End;
	 Close (TextFile);		{zavreni souboru}
	 IO_OK:=True;
	End
	Else
	Begin
           Citac.Zprava5;
           Citac.CZ_Dialog_Box;
	  IO_OK := False;
	End;
   SetLimit  (MaxLength,LineColl^.Count)  	{scroll limit}
End;
{------------------------------------------------}
Procedure TContens.Draw;
{zapis textoveho radku}
	VAR
	  DrawBuf	:TDrawBuffer;		{vnitrni buffer radku}
	  StrPtr	:PString;		{ukazatel na dynamicky retezec}
	  S		:String;		{staticky retezec}
	  VisualLine	:Word;			{promenna pro viditelne	radky}
	  Color		:Byte;			{atributovy byte}

Begin
	Color:=GetColor(1);		{normalni,ne intenzivni}
	For VisualLine := 0 To Pred (Size.Y) Do
	Begin
	 MoveChar (DrawBuf,' ',Color,Size.X);
	 If Delta.Y + VisualLine < LineColl^.Count Then
		Begin
		 StrPtr :=LineColl^.At (Delta.Y + VisualLine);
	 	 If StrPtr <> NIL Then
		  S:= Copy (StrPtr^,Succ (Delta.X),Size.X)
		  Else S:='';
		MoveStr (DrawBuf,S,Color)
		End;
		WriteLine (0,VisualLine,Size.X,1,DrawBuf)
	End
End;
{------------------------------------------------}
Function TContens.Valid;
{test,zda se pri vystavbe Collection vyskytla chyba}
Begin
  Valid:= IO_OK
END;
{------------------------------------------------}
Destructor TContens.Done;
{odstraneni Collection a objektu predchudce}
Begin
Dispose (LineColl,Done);
TScroller.Done;
End;
{------------------------------------------------}
Procedure TLineColl.FreeItem;
 {odstraneni radku z haldy}
	Begin
	 DisposeStr (P)		{metodu predchudce nepotrebujeme}
	End;
{------------------------------------------------}
Procedure TCitac.Vyber;   {Zobrazi dialog box s InpulLine pro nastaveni intervalu mezi merenim}
Var                       {a s CheckBox-em pro nastaveni,zda je pozadavek ukladat do souboru i cas mereni}
 Rect	: TRect;          {as vlastnim spustenim mereni a ukladani dat}
 Dialog	: PDialog;
 InputLn: PInputLine;			{objekt Input-Line}
 View	: PView;			{ukazuje na prvek View}
 CheckBoxData : Word;

 Label    Zpet;
Begin
        Begin
        With BoxData Do			{implicitni udaje dialogoveho okna}
	Begin
		InputLineData:= '1';	{nastaveni intervalu zaznamu na 1 sec.}
		CheckBoxData:= 0;	{policko check box vybrane}
	End;

	Rect.Assign (5,4,73,14);	{udaje pro pravouhelnik}
	Dialog :=
	  New (PDialog,Init (Rect,'ZADEJTE PARAMETRY UKLADANI'));
	  With Dialog^ Do
	  	Begin
		 Rect.Assign (59,2,65,3);	{udaje pro input line}
		 InputLn:=New (PInputLine,Init(Rect,4));
                 Insert (InputLn);		{vlozit do dialogoveho okna}
		 Rect.Assign (1,2,59,3);	{udaje pro navesti InputLine}
		 Insert (New (PLabel,
			Init (Rect,'Zadejte interval mereni v sekundach v rozsahu 1 az 3000:',InputLn)
		 ));
		Rect.Assign (14,4,54,5);	{udaje pro tlacitko typu Check Box}
		Insert (New (PCheckBoxes,Init (Rect,
				NewSItem ('Pripojit k zaznamu dat zaznam casu',
				NIL))));
		Rect.Assign (20,7,30,9);	{udaje pro tlacitko OK}
		Insert (New (PButton,
			Init (Rect,'Spustit',cmOK,bfDefault)	{predvolene tlacitko}
			));
		Rect.Assign (35,7,45,9);	{udaje pro tlacitko Cancel}
		Insert (New (PButton,
			Init (Rect,'Zrusit',cmCancel,bfNormal)
			));
		SelectNext (False);
                Dialog^.SetData(BoxData);
	    	End;

{Zde zobrazeni okna a nacteni parametru}
Zpet:           	If DeskTop^.ExecView(Dialog) <> cmCancel Then
                        With BoxData Do
	                Begin
                        Dialog^.GetData (BoxData);          {precteni hodnot}
                        Val(InputLineData,NacitaniDat,x);   {prevedeni ze stringu na cislo}
                        If (NacitaniDat < 0) or (NacitaniDat > 3000) then
                                                               Begin   {Data mimo rozsah}
                                                               Citac.Zprava4;
                                                               Citac.CZ_Dialog_Box;
                                                               InputLineData:='    ';{Vymaz radek}
                                                               InputLn^.SetData(InputLineData);{Zapis radek}
                                                               Goto Zpet;         {Jdi zpet na InputBox a cekej na zadani}
                                                               End;

                	Begin
                                  If CheckBoxData=1 Then Begin   {Nastaveni zaznamu casu dle zaskrtnuti checkboxu}
                                                           Cas:=True;
                                                           End
                                          Else             Begin
                                                           Cas:=False;
                                                           End;

                              DisableCommands([cmZapUkl]);         {Vlastni spusteni zaznamu dat}
                              Gettime (hodina,minuta,sekunda,sec100);    {Uloz prvni cas}
                              minsec:=sekunda;
                              Time:=0;                    {software citac vterin,protoze sekundy se po 59 nuluji}
                              Ukladani:=True;             {Umozni vstup do tela Idle metody}
                              i2:=0;
                              Vypni;                      {Zobraz okno umoznujici vypnuti mereni a ukladani dat}
                              End ;
			      End;
End;
      End;
{------------------------------------------------}
Procedure TCitac.Vypni;
{Okno,umoznujici vypnuti mereni a ukladani dat do souboru}
Var
 Rect	: TRect;
 Dialog	: PDialog;
 View	: PView;			{ukazuje na prvek View}
Begin
        Rect.Assign (5,4,50,13);	{udaje pro pravouhelnik}
	Dialog :=
	  New (PDialog,Init (Rect,'MERENI A UKLADANI DAT'));
	  With Dialog^ Do
	  	Begin
		 Rect.Assign (1,2,44,3);	{udaje pro navesti}
		 Insert (New (PLabel,
			Init (Rect,'  Probiha mereni dat a jejich ukladani.',nil)
		 ));
		Rect.Assign (8,5,37,7);	{udaje pro tlacitko OK}
		Insert (New (PButton,
			Init (Rect,'UKONCIT MERENI A UKLADANI',cmOK,bfDefault)	{predvolene tlacitko}
			));
                Options:=ofCentered; {nastav okno do stredu}
                Flags:=0;  {Nastaveni flagu pro nezobrazeni ctverecku na uzavreni okna,nemozno posouvat okno a menit velikost}
		SelectNext (False);
                End;


           	If DeskTop^.ExecView(Dialog) = cmOK Then       {Po stisku ukonceni mereni zastav mereni,vrat se do hlavniho menu}
                                                    Begin
                                                    EnableCommands([cmZapUkl]);
                                                    Ukladani:=False;
                                                    End;
End;
{------------------------------------------------}
Begin                                  {Beh aplikace}
      prijem:=false;
      Konec:=false;
      Ukladani:=False;        {priznak pro spusteni ukladani do souboru}
      MinSec:=0;              {Promenna pro ulozeni minuleho stavu sekund}
      NacitaniDat:=1;         {Implicitni hodnota pro nacitani dat = 1sec.}
      VybSoubOK:=False;       {Priznak,ktery indikuje,ze byl urcen vystupni soubor}
      Cas:=False;             {Priznak pro spusteni zaznamu casu k datum v souboru}
      Zvuk:=False;            {Priznak pro pipnuti pri chybe}

    Citac.Init;
    Citac.MujInit;
    Citac.Run;
    Citac.Done;
    End.







